#include <stdio.h>
#include <string.h>
#include <gtk/gtk.h>

int main(int argc,char **argv){
	FILE *file,*ofile;
	char *p,line[4096];
	gchar *g=NULL,*gg=NULL;
    GError *error = NULL;
    gsize r_bytes, w_bytes;
	
	file = fopen(argv[1],"r+");
	if (!file) {printf("invalid argument %s\n",argv[1]);exit(1);}
	sprintf(line,"utf-8/%s",argv[1]);
	ofile = fopen(line,"w+");
	if (!ofile) {printf("invalid argument %s\n",line);exit(1);}
	printf("%s: charset is ",argv[1]);
	while (!feof(file) && fgets(line,4095,file)!=0){
		if (g) {
    			gg = g_convert (line,strlen(line),
					"UTF-8",
					g,
					&r_bytes, &w_bytes, &error);
    if(error){
        printf("DBG: %s. Codeset for system is: %s\n",
			error->message,g);
	g_error_free(error);
	error=NULL;
    }
			fprintf(ofile,"%s",gg);		
			g_free(gg);
			gg=NULL;
		}
		else {
		  if (strstr(line,"charset=")){
			p=strstr(line,"charset=")+strlen("charset=");
			p=strtok(p,"\n");
			if (strstr(p,"\\")) *strstr(p,"\\")=0;
			g=g_ascii_strup(p,-1);
			// change to upper
			printf("%s",g);
			sprintf(p,"UTF-8\\n\"\n");
			fprintf(ofile,"%s",line);
		  }	
		  else fprintf(ofile,"%s",line);	  
		} 		
	}
	fclose(file);
	printf("\n");

	
	return 1;
}
		
